=== debian/control ===
Source: mesa-glu
Section: graphics
Priority: optional
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Uploaders: Cyril Brulebois <kibi@debian.org>
Standards-Version: 3.8.4
Build-Depends:
 debhelper (>= 8.1.3),
 quilt (>= 0.40),
 pkg-config,
 libdrm-dev (>= 2.4.30) [!hurd-any],
 libx11-dev,
 xutils-dev,
 x11proto-gl-dev (>= 1.4.14),
 libxxf86vm-dev,
 libexpat1-dev,
 dpkg-dev (>= 1.15.6),
 libxfixes-dev,
 libxdamage-dev,
 libxext-dev,
 autoconf,
 automake,
 x11proto-dri2-dev (>= 2.6),
 linux-libc-dev (>= 2.6.31) [linux-any],
 libx11-xcb-dev,
 libxcb-dri2-0-dev,
 libxcb-glx0-dev,
 libxcb-xfixes0-dev,
 python-libxml2,
 libudev-dev [linux-any],
 flex,
 bison,
 llvm-2.9-dev [amd64 i386 kfreebsd-amd64 kfreebsd-i386],
 libwayland-dev (>= 0.85.0) [linux-any],
Vcs-Git: git://git.debian.org/git/pkg-xorg/lib/mesa-glu
Vcs-Browser: http://git.debian.org/?p=pkg-xorg/lib/mesa-glu.git
Homepage: http://mesa3d.sourceforge.net/

Package: libglu1-mesa
Section: libs
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Provides: libglu1
Conflicts: mesag3 (<< 5.0.0-1), xlibmesa3, libglu1
Replaces: libglu1
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Mesa OpenGL utility library (GLU)
 GLU offers simple interfaces for building mipmaps; checking for the
 presence of extensions in the OpenGL (or other libraries which follow
 the same conventions for advertising extensions); drawing
 piecewise-linear curves, NURBS, quadrics and other primitives
 (including, but not limited to, teapots); tesselating surfaces; setting
 up projection matrices and unprojecting screen coordinates to world
 coordinates.
 .
 On Linux, this library is also known as libGLU or libGLU.so.1.
 .
 This package provides the SGI implementation of GLU shipped with the
 Mesa package (ergo the "-mesa" suffix).

Package: libglu1-mesa-dev
Section: libdevel
Architecture: any
Depends:
 libglu1-mesa (= ${binary:Version}),
 libgl1-mesa-dev | libgl-dev,
 ${misc:Depends},
Provides: libglu-dev, xlibmesa-glu-dev
Conflicts: mesag-dev (<< 5.0.0-1), mesa-glide2-dev (<< 5.0.0-1), mesag3+ggi-dev (<< 5.0.0-1), xlibmesa-dev
Replaces: libglu-dev
Description: Mesa OpenGL utility library -- development files
 Includes headers and static libraries for compiling programs with GLU.
 .
 For a complete description of GLU, please look at the libglu1-mesa
 package.

# vim: tw=0
