=== debian/watch ===
#git=git://anongit.freedesktop.org/mesa/glu
version=3
opts="uversionmangle=s/-rc/~rc/,dversionmangle=s/\+repack//,pasv" \
ftp://freedesktop.org/pub/mesa/glu/glu-(.*)\.tar\.bz2
